Framework: add 2n-tx2 perf testbed
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
202     #   The name is chosen to match what ci-management expects.
203     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
204     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
205     # Directories created if not present:
206     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
207     # Functions called:
208     # - die - Print to stderr and exit.
209
210     set -exuo pipefail
211
212     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
213         die "Some error during locating of this source file."
214     }
215     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
216         die "Some error during dirname call."
217     }
218     # Current working directory could be in a different repo, e.g. VPP.
219     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
220     relative_csit_dir=$(git rev-parse --show-toplevel) || {
221         die "Git rev-parse failed."
222     }
223     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
224     popd || die "Popd failed."
225     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
226         die "Readlink failed."
227     }
228     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
229         die "Readlink failed."
230     }
231     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
232         die "Readlink failed."
233     }
234     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
235         die "Readlink failed."
236     }
237     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
238         die "Readlink failed."
239     }
240     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
241         die "Readlink failed."
242     }
243
244     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
248     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
249         die "Readlink failed."
250     }
251     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
252     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
253         die "Readlink failed."
254     }
255     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
256 }
257
258
259 function compose_pybot_arguments () {
260
261     # Variables read:
262     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
263     # - DUT - CSIT test/ subdirectory, set while processing tags.
264     # - TAGS - Array variable holding selected tag boolean expressions.
265     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
266     # - TEST_CODE - The test selection string from environment or argument.
267     # Variables set:
268     # - PYBOT_ARGS - String holding part of all arguments for pybot.
269     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
270
271     set -exuo pipefail
272
273     # No explicit check needed with "set -u".
274     PYBOT_ARGS=("--loglevel" "TRACE")
275     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
276
277     case "${TEST_CODE}" in
278         *"device"*)
279             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
280             ;;
281         *"perf"*)
282             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
283             ;;
284         *)
285             die "Unknown specification: ${TEST_CODE}"
286     esac
287
288     EXPANDED_TAGS=()
289     for tag in "${TAGS[@]}"; do
290         if [[ ${tag} == "!"* ]]; then
291             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
292         else
293             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
294         fi
295     done
296 }
297
298
299 function deactivate_docker_topology () {
300
301     # Deactivate virtual vpp-device topology by removing containers.
302     #
303     # Variables read:
304     # - NODENESS - Node multiplicity of desired testbed.
305     # - FLAVOR - Node flavor string, usually describing the processor.
306
307     set -exuo pipefail
308
309     case_text="${NODENESS}_${FLAVOR}"
310     case "${case_text}" in
311         "1n_skx" | "1n_tx2")
312             ssh="ssh root@172.17.0.1 -p 6022"
313             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
314             # The "declare -f" output is long and boring.
315             set +x
316             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
317                 die "Topology cleanup via shim-dcr failed!"
318             }
319             set -x
320             ;;
321         "1n_vbox")
322             enter_mutex || die
323             clean_environment || {
324                 die "Topology cleanup locally failed!"
325             }
326             exit_mutex || die
327             ;;
328         *)
329             die "Unknown specification: ${case_text}!"
330     esac
331 }
332
333
334 function die () {
335
336     # Print the message to standard error end exit with error code specified
337     # by the second argument.
338     #
339     # Hardcoded values:
340     # - The default error message.
341     # Arguments:
342     # - ${1} - The whole error message, be sure to quote. Optional
343     # - ${2} - the code to exit with, default: 1.
344
345     set -x
346     set +eu
347     warn "${1:-Unspecified run-time error occurred!}"
348     exit "${2:-1}"
349 }
350
351
352 function die_on_pybot_error () {
353
354     # Source this fragment if you want to abort on any failed test case.
355     #
356     # Variables read:
357     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
358     # Functions called:
359     # - die - Print to stderr and exit.
360
361     set -exuo pipefail
362
363     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
364         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
365     fi
366 }
367
368
369 function generate_tests () {
370
371     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
372     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
373     # The generation is done by executing any *.py executable
374     # within any subdirectory after copying.
375
376     # This is a separate function, because this code is called
377     # both by autogen checker and entries calling run_pybot.
378
379     # Directories read:
380     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
381     # Directories replaced:
382     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
383
384     set -exuo pipefail
385
386     rm -rf "${GENERATED_DIR}/tests" || die
387     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
388     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
389     cmd_line+=("-executable" "-name" "*.py")
390     # We sort the directories, so log output can be compared between runs.
391     file_list=$("${cmd_line[@]}" | sort) || die
392
393     for gen in ${file_list}; do
394         directory="$(dirname "${gen}")" || die
395         filename="$(basename "${gen}")" || die
396         pushd "${directory}" || die
397         ./"${filename}" || die
398         popd || die
399     done
400 }
401
402
403 function get_test_code () {
404
405     # Arguments:
406     # - ${1} - Optional, argument of entry script (or empty as unset).
407     #   Test code value to override job name from environment.
408     # Variables read:
409     # - JOB_NAME - String affecting test selection, default if not argument.
410     # Variables set:
411     # - TEST_CODE - The test selection string from environment or argument.
412     # - NODENESS - Node multiplicity of desired testbed.
413     # - FLAVOR - Node flavor string, usually describing the processor.
414
415     set -exuo pipefail
416
417     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
418     if [[ -z "${TEST_CODE}" ]]; then
419         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
420     fi
421
422     case "${TEST_CODE}" in
423         *"1n-vbox"*)
424             NODENESS="1n"
425             FLAVOR="vbox"
426             ;;
427         *"1n-skx"*)
428             NODENESS="1n"
429             FLAVOR="skx"
430             ;;
431        *"1n-tx2"*)
432             NODENESS="1n"
433             FLAVOR="tx2"
434             ;;
435         *"2n-skx"*)
436             NODENESS="2n"
437             FLAVOR="skx"
438             ;;
439         *"2n-zn2"*)
440             NODENESS="2n"
441             FLAVOR="zn2"
442             ;;
443         *"3n-skx"*)
444             NODENESS="3n"
445             FLAVOR="skx"
446             ;;
447         *"2n-clx"*)
448             NODENESS="2n"
449             FLAVOR="clx"
450             ;;
451         *"2n-dnv"*)
452             NODENESS="2n"
453             FLAVOR="dnv"
454             ;;
455         *"3n-dnv"*)
456             NODENESS="3n"
457             FLAVOR="dnv"
458             ;;
459         *"2n-tx2"*)
460             NODENESS="2n"
461             FLAVOR="tx2"
462             ;;
463         *"3n-tsh"*)
464             NODENESS="3n"
465             FLAVOR="tsh"
466             ;;
467         *)
468             # Fallback to 3-node Haswell by default (backward compatibility)
469             NODENESS="3n"
470             FLAVOR="hsw"
471             ;;
472     esac
473 }
474
475
476 function get_test_tag_string () {
477
478     # Variables read:
479     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
480     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
481     # - TEST_CODE - The test selection string from environment or argument.
482     # Variables set:
483     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
484     #   May be empty, or even not set on event types not adding comment.
485
486     # TODO: ci-management scripts no longer need to perform this.
487
488     set -exuo pipefail
489
490     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
491         case "${TEST_CODE}" in
492             *"device"*)
493                 trigger="devicetest"
494                 ;;
495             *"perf"*)
496                 trigger="perftest"
497                 ;;
498             *)
499                 die "Unknown specification: ${TEST_CODE}"
500         esac
501         # Ignore lines not containing the trigger word.
502         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
503         # The vpp-csit triggers trail stuff we are not interested in.
504         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
505         # (except relying on \s whitespace, \S non-whitespace and . both).
506         # The last string is concatenated, only the middle part is expanded.
507         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
508         # On parsing error, TEST_TAG_STRING probably stays empty.
509         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
510         if [[ -z "${TEST_TAG_STRING-}" ]]; then
511             # Probably we got a base64 encoded comment.
512             comment=$(base64 --decode <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
513             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
514             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
515         fi
516         if [[ -n "${TEST_TAG_STRING-}" ]]; then
517             test_tag_array=(${TEST_TAG_STRING})
518             if [[ "${test_tag_array[0]}" == "icl" ]]; then
519                 export GRAPH_NODE_VARIANT="icl"
520                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
521             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
522                 export GRAPH_NODE_VARIANT="skx"
523                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
524             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
525                 export GRAPH_NODE_VARIANT="hsw"
526                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
527             fi
528         fi
529     fi
530 }
531
532
533 function installed () {
534
535     # Check if the given utility is installed. Fail if not installed.
536     #
537     # Duplicate of common.sh function, as this file is also used standalone.
538     #
539     # Arguments:
540     # - ${1} - Utility to check.
541     # Returns:
542     # - 0 - If command is installed.
543     # - 1 - If command is not installed.
544
545     set -exuo pipefail
546
547     command -v "${1}"
548 }
549
550
551 function move_archives () {
552
553     # Move archive directory to top of workspace, if not already there.
554     #
555     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
556     # but in some jobs CSIT_DIR is not same as WORKSPACE
557     # (e.g. under VPP_DIR). To simplify ci-management settings,
558     # we want to move the data to the top. We do not want simple copy,
559     # as ci-management is eager with recursive search.
560     #
561     # As some scripts may call this function multiple times,
562     # the actual implementation use copying and deletion,
563     # so the workspace gets "union" of contents (except overwrites on conflict).
564     # The consequence is empty ARCHIVE_DIR remaining after this call.
565     #
566     # As the source directory is emptied,
567     # the check for dirs being different is essential.
568     #
569     # Variables read:
570     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
571     #   Can be unset, then it speeds up manual testing.
572     # - ARCHIVE_DIR - Path to directory with content to be moved.
573     # Directories updated:
574     # - ${WORKSPACE}/archives/ - Created if does not exist.
575     #   Content of ${ARCHIVE_DIR}/ is moved.
576     # Functions called:
577     # - die - Print to stderr and exit.
578
579     set -exuo pipefail
580
581     if [[ -n "${WORKSPACE-}" ]]; then
582         target=$(readlink -f "${WORKSPACE}/archives")
583         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
584             mkdir -p "${target}" || die "Archives dir create failed."
585             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
586             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
587         fi
588     fi
589 }
590
591
592 function reserve_and_cleanup_testbed () {
593
594     # Reserve physical testbed, perform cleanup, register trap to unreserve.
595     # When cleanup fails, remove from topologies and keep retrying
596     # until all topologies are removed.
597     #
598     # Variables read:
599     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
600     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
601     # - BUILD_TAG - Any string suitable as filename, identifying
602     #   test run executing this function. May be unset.
603     # Variables set:
604     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
605     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
606     # Functions called:
607     # - die - Print to stderr and exit.
608     # - ansible_playbook - Perform an action using ansible, see ansible.sh
609     # Traps registered:
610     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
611
612     set -exuo pipefail
613
614     while true; do
615         for topo in "${TOPOLOGIES[@]}"; do
616             set +e
617             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
618             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
619             python3 "${scrpt}" "${opts[@]}"
620             result="$?"
621             set -e
622             if [[ "${result}" == "0" ]]; then
623                 # Trap unreservation before cleanup check,
624                 # so multiple jobs showing failed cleanup improve chances
625                 # of humans to notice and fix.
626                 WORKING_TOPOLOGY="${topo}"
627                 echo "Reserved: ${WORKING_TOPOLOGY}"
628                 trap "untrap_and_unreserve_testbed" EXIT || {
629                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
630                     untrap_and_unreserve_testbed "${message}" || {
631                         die "Teardown should have died, not failed."
632                     }
633                     die "Trap attempt failed, unreserve succeeded. Aborting."
634                 }
635                 # Cleanup + calibration checks.
636                 set +e
637                 ansible_playbook "cleanup, calibration"
638                 result="$?"
639                 set -e
640                 if [[ "${result}" == "0" ]]; then
641                     break
642                 fi
643                 warn "Testbed cleanup failed: ${topo}"
644                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
645             fi
646             # Else testbed is accessible but currently reserved, moving on.
647         done
648
649         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
650             # Exit the infinite while loop if we made a reservation.
651             warn "Reservation and cleanup successful."
652             break
653         fi
654
655         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
656             die "Run out of operational testbeds!"
657         fi
658
659         # Wait ~3minutes before next try.
660         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
661             die "Sleep time calculation failed."
662         }
663         echo "Sleeping ${sleep_time}"
664         sleep "${sleep_time}" || die "Sleep failed."
665     done
666 }
667
668
669 function run_pybot () {
670
671     # Run pybot with options based on input variables. Create output_info.xml
672     #
673     # Variables read:
674     # - CSIT_DIR - Path to existing root of local CSIT git repository.
675     # - ARCHIVE_DIR - Path to store robot result files in.
676     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
677     # - GENERATED_DIR - Tests are assumed to be generated under there.
678     # Variables set:
679     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
680     # Functions called:
681     # - die - Print to stderr and exit.
682
683     set -exuo pipefail
684
685     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
686     all_options+=("--noncritical" "EXPECTED_FAILING")
687     all_options+=("${EXPANDED_TAGS[@]}")
688
689     pushd "${CSIT_DIR}" || die "Change directory operation failed."
690     set +e
691     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
692     PYBOT_EXIT_STATUS="$?"
693     set -e
694
695     # Generate INFO level output_info.xml for post-processing.
696     all_options=("--loglevel" "INFO")
697     all_options+=("--log" "none")
698     all_options+=("--report" "none")
699     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
700     all_options+=("${ARCHIVE_DIR}/output.xml")
701     rebot "${all_options[@]}" || true
702     popd || die "Change directory operation failed."
703 }
704
705
706 function select_arch_os () {
707
708     # Set variables affected by local CPU architecture and operating system.
709     #
710     # Variables set:
711     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
712     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
713     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
714
715     set -exuo pipefail
716
717     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
718         die "Get OS release failed."
719     }
720
721     case "${os_id}" in
722         "ubuntu"*)
723             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
724             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
725             PKG_SUFFIX="deb"
726             ;;
727         "centos"*)
728             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
729             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
730             PKG_SUFFIX="rpm"
731             ;;
732         *)
733             die "Unable to identify distro or os from ${os_id}"
734             ;;
735     esac
736
737     arch=$(uname -m) || {
738         die "Get CPU architecture failed."
739     }
740
741     case "${arch}" in
742         "aarch64")
743             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
744             ;;
745         *)
746             ;;
747     esac
748 }
749
750
751 function select_tags () {
752
753     # Variables read:
754     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
755     # - TEST_CODE - String affecting test selection, usually jenkins job name.
756     # - DUT - CSIT test/ subdirectory, set while processing tags.
757     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
758     #   Can be unset.
759     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
760     # - BASH_FUNCTION_DIR - Directory with input files to process.
761     # Variables set:
762     # - TAGS - Array of processed tag boolean expressions.
763
764     set -exuo pipefail
765
766     # NIC SELECTION
767     start_pattern='^  TG:'
768     end_pattern='^ \? \?[A-Za-z0-9]\+:'
769     # Remove the TG section from topology file
770     sed_command="/${start_pattern}/,/${end_pattern}/d"
771     # All topologies DUT NICs
772     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
773                 | grep -hoP "model: \K.*" | sort -u)
774     # Selected topology DUT NICs
775     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
776                | grep -hoP "model: \K.*" | sort -u)
777     # All topologies DUT NICs - Selected topology DUT NICs
778     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
779         die "Computation of excluded NICs failed."
780     }
781
782     # Select default NIC tag.
783     case "${TEST_CODE}" in
784         *"3n-dnv"* | *"2n-dnv"*)
785             default_nic="nic_intel-x553"
786             ;;
787         *"3n-tsh"*)
788             default_nic="nic_intel-x520-da2"
789             ;;
790         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
791             default_nic="nic_intel-xxv710"
792             ;;
793         *"3n-hsw"* | *"2n-tx2"* | *"mrr-daily-master")
794             default_nic="nic_intel-xl710"
795             ;;
796         *)
797             default_nic="nic_intel-x710"
798             ;;
799     esac
800
801     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
802     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
803     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
804     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
805     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
806     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
807     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
808     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
809     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
810     # Tag file directory shorthand.
811     tfd="${JOB_SPECS_DIR}"
812     case "${TEST_CODE}" in
813         # Select specific performance tests based on jenkins job type variable.
814         *"ndrpdr-weekly"* )
815             readarray -t test_tag_array <<< $(sed 's/ //g' \
816                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
817                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
818             ;;
819         *"mrr-daily"* )
820             readarray -t test_tag_array <<< $(sed 's/ //g' \
821                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
822                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
823             ;;
824         *"mrr-weekly"* )
825             readarray -t test_tag_array <<< $(sed 's/ //g' \
826                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
827                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
828             ;;
829         *"report-iterative"* )
830             test_sets=(${TEST_TAG_STRING//:/ })
831             # Run only one test set per run
832             report_file=${test_sets[0]}.md
833             readarray -t test_tag_array <<< $(sed 's/ //g' \
834                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
835                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
836             ;;
837         *"report-coverage"* )
838             test_sets=(${TEST_TAG_STRING//:/ })
839             # Run only one test set per run
840             report_file=${test_sets[0]}.md
841             readarray -t test_tag_array <<< $(sed 's/ //g' \
842                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
843                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
844             ;;
845         * )
846             if [[ -z "${TEST_TAG_STRING-}" ]]; then
847                 # If nothing is specified, we will run pre-selected tests by
848                 # following tags.
849                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
850                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
851                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
852                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
853                                 "!dot1q" "!drv_avf")
854             else
855                 # If trigger contains tags, split them into array.
856                 test_tag_array=(${TEST_TAG_STRING//:/ })
857             fi
858             ;;
859     esac
860
861     # Blacklisting certain tags per topology.
862     #
863     # Reasons for blacklisting:
864     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
865     # TODO: Add missing reasons here (if general) or where used (if specific).
866     case "${TEST_CODE}" in
867         *"2n-skx"*)
868             test_tag_array+=("!ipsec")
869             ;;
870         *"3n-skx"*)
871             test_tag_array+=("!ipsechw")
872             # Not enough nic_intel-xxv710 to support double link tests.
873             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
874             ;;
875         *"2n-clx"*)
876             test_tag_array+=("!ipsec")
877             ;;
878         *"2n-zn2"*)
879             test_tag_array+=("!ipsec")
880             ;;
881         *"2n-dnv"*)
882             test_tag_array+=("!ipsechw")
883             test_tag_array+=("!memif")
884             test_tag_array+=("!srv6_proxy")
885             test_tag_array+=("!vhost")
886             test_tag_array+=("!vts")
887             test_tag_array+=("!drv_avf")
888             ;;
889         *"2n-tx2"*)
890             test_tag_array+=("!ipsechw")
891             ;;
892         *"3n-dnv"*)
893             test_tag_array+=("!memif")
894             test_tag_array+=("!srv6_proxy")
895             test_tag_array+=("!vhost")
896             test_tag_array+=("!vts")
897             test_tag_array+=("!drv_avf")
898             ;;
899         *"3n-tsh"*)
900             # 3n-tsh only has x520 NICs which don't work with AVF
901             test_tag_array+=("!drv_avf")
902             test_tag_array+=("!ipsechw")
903             ;;
904         *"3n-hsw"*)
905             test_tag_array+=("!drv_avf")
906             # All cards have access to QAT. But only one card (xl710)
907             # resides in same NUMA as QAT. Other cards must go over QPI
908             # which we do not want to even run.
909             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
910             ;;
911         *)
912             # Default to 3n-hsw due to compatibility.
913             test_tag_array+=("!drv_avf")
914             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
915             ;;
916     esac
917
918     # We will add excluded NICs.
919     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
920
921     TAGS=()
922
923     # We will prefix with perftest to prevent running other tests
924     # (e.g. Functional).
925     prefix="perftestAND"
926     set +x
927     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
928         # Automatic prefixing for VPP jobs to limit the NIC used and
929         # traffic evaluation to MRR.
930         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
931             prefix="${prefix}mrrAND"
932         else
933             prefix="${prefix}mrrAND${default_nic}AND"
934         fi
935     fi
936     for tag in "${test_tag_array[@]}"; do
937         if [[ "${tag}" == "!"* ]]; then
938             # Exclude tags are not prefixed.
939             TAGS+=("${tag}")
940         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
941             # Badly formed tag expressions can trigger way too much tests.
942             set -x
943             warn "The following tag expression hints at bad trigger: ${tag}"
944             warn "Possible cause: Multiple triggers in a single comment."
945             die "Aborting to avoid triggering too many tests."
946         elif [[ "${tag}" == *"OR"* ]]; then
947             # If OR had higher precedence than AND, it would be useful here.
948             # Some people think it does, thus triggering way too much tests.
949             set -x
950             warn "The following tag expression hints at bad trigger: ${tag}"
951             warn "Operator OR has lower precedence than AND. Use space instead."
952             die "Aborting to avoid triggering too many tests."
953         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
954             # Empty and comment lines are skipped.
955             # Other lines are normal tags, they are to be prefixed.
956             TAGS+=("${prefix}${tag}")
957         fi
958     done
959     set -x
960 }
961
962
963 function select_topology () {
964
965     # Variables read:
966     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
967     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
968     # - CSIT_DIR - Path to existing root of local CSIT git repository.
969     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
970     # Variables set:
971     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
972     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
973     # Functions called:
974     # - die - Print to stderr and exit.
975
976     set -exuo pipefail
977
978     case_text="${NODENESS}_${FLAVOR}"
979     case "${case_text}" in
980         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
981         # TODO: Double link availability depends on NIC used.
982         "1n_vbox")
983             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
984             TOPOLOGIES_TAGS="2_node_single_link_topo"
985             ;;
986         "1n_skx" | "1n_tx2")
987             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
988             TOPOLOGIES_TAGS="2_node_single_link_topo"
989             ;;
990         "2n_skx")
991             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
992             TOPOLOGIES_TAGS="2_node_*_link_topo"
993             ;;
994         "2n_zn2")
995             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
996             TOPOLOGIES_TAGS="2_node_*_link_topo"
997             ;;
998         "3n_skx")
999             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1000             TOPOLOGIES_TAGS="3_node_*_link_topo"
1001             ;;
1002         "2n_clx")
1003             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1004             TOPOLOGIES_TAGS="2_node_*_link_topo"
1005             ;;
1006         "2n_dnv")
1007             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1008             TOPOLOGIES_TAGS="2_node_single_link_topo"
1009             ;;
1010         "3n_dnv")
1011             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1012             TOPOLOGIES_TAGS="3_node_single_link_topo"
1013             ;;
1014         "3n_hsw")
1015             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
1016             TOPOLOGIES_TAGS="3_node_single_link_topo"
1017             ;;
1018         "3n_tsh")
1019             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1020             TOPOLOGIES_TAGS="3_node_single_link_topo"
1021             ;;
1022         "2n_tx2")
1023             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1024             TOPOLOGIES_TAGS="2_node_single_link_topo"
1025             ;;
1026         *)
1027             # No falling back to 3n_hsw default, that should have been done
1028             # by the function which has set NODENESS and FLAVOR.
1029             die "Unknown specification: ${case_text}"
1030     esac
1031
1032     if [[ -z "${TOPOLOGIES-}" ]]; then
1033         die "No applicable topology found!"
1034     fi
1035 }
1036
1037
1038 function select_vpp_device_tags () {
1039
1040     # Variables read:
1041     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1042     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1043     #   Can be unset.
1044     # Variables set:
1045     # - TAGS - Array of processed tag boolean expressions.
1046
1047     set -exuo pipefail
1048
1049     case "${TEST_CODE}" in
1050         # Select specific device tests based on jenkins job type variable.
1051         * )
1052             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1053                 # If nothing is specified, we will run pre-selected tests by
1054                 # following tags. Items of array will be concatenated by OR
1055                 # in Robot Framework.
1056                 test_tag_array=()
1057             else
1058                 # If trigger contains tags, split them into array.
1059                 test_tag_array=(${TEST_TAG_STRING//:/ })
1060             fi
1061             ;;
1062     esac
1063
1064     # Blacklisting certain tags per topology.
1065     #
1066     # Reasons for blacklisting:
1067     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1068     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1069     case "${TEST_CODE}" in
1070         *"1n-vbox"*)
1071             test_tag_array+=("!avf")
1072             test_tag_array+=("!vhost")
1073             ;;
1074         *)
1075             ;;
1076     esac
1077
1078     TAGS=()
1079
1080     # We will prefix with devicetest to prevent running other tests
1081     # (e.g. Functional).
1082     prefix="devicetestAND"
1083     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1084         # Automatic prefixing for VPP jobs to limit testing.
1085         prefix="${prefix}"
1086     fi
1087     for tag in "${test_tag_array[@]}"; do
1088         if [[ ${tag} == "!"* ]]; then
1089             # Exclude tags are not prefixed.
1090             TAGS+=("${tag}")
1091         else
1092             TAGS+=("${prefix}${tag}")
1093         fi
1094     done
1095 }
1096
1097 function untrap_and_unreserve_testbed () {
1098
1099     # Use this as a trap function to ensure testbed does not remain reserved.
1100     # Perhaps call directly before script exit, to free testbed for other jobs.
1101     # This function is smart enough to avoid multiple unreservations (so safe).
1102     # Topo cleanup is executed (call it best practice), ignoring failures.
1103     #
1104     # Hardcoded values:
1105     # - default message to die with if testbed might remain reserved.
1106     # Arguments:
1107     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1108     # Variables read (by inner function):
1109     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1110     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1111     # Variables written:
1112     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1113     # Trap unregistered:
1114     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1115     # Functions called:
1116     # - die - Print to stderr and exit.
1117     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1118
1119     set -xo pipefail
1120     set +eu  # We do not want to exit early in a "teardown" function.
1121     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1122     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1123     if [[ -z "${wt-}" ]]; then
1124         set -eu
1125         warn "Testbed looks unreserved already. Trap removal failed before?"
1126     else
1127         ansible_playbook "cleanup" || true
1128         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1129             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1130         }
1131         WORKING_TOPOLOGY=""
1132         set -eu
1133     fi
1134 }
1135
1136
1137 function warn () {
1138
1139     # Print the message to standard error.
1140     #
1141     # Arguments:
1142     # - ${@} - The text of the message.
1143
1144     set -exuo pipefail
1145
1146     echo "$@" >&2
1147 }